manage 16 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527
  1. #!/usr/bin/env bash
  2. # -*- coding: utf-8; mode: sh indent-tabs-mode: nil -*-
  3. # SPDX-License-Identifier: AGPL-3.0-or-later
  4. # shellcheck disable=SC2031
  5. # shellcheck source=utils/lib.sh
  6. source "$(dirname "${BASH_SOURCE[0]}")/utils/lib.sh"
  7. # shellcheck source=utils/brand.env
  8. source "${REPO_ROOT}/utils/brand.env"
  9. source_dot_config
  10. # config
  11. PYOBJECTS="searx"
  12. PY_SETUP_EXTRAS='[test]'
  13. NPM_PACKAGES="less@2.7 less-plugin-clean-css grunt-cli"
  14. GECKODRIVER_VERSION="v0.28.0"
  15. # SPHINXOPTS=
  16. pylint.FILES() {
  17. # List files tagged by comment:
  18. #
  19. # # lint: pylint
  20. #
  21. # These py files are linted by test.pylint(), all other files are linted by
  22. # test.pep8()
  23. grep -l -r --include \*.py '^#[[:blank:]]*lint:[[:blank:]]*pylint' searx searx_extra tests
  24. }
  25. YAMLLINT_FILES=()
  26. while IFS= read -r line; do
  27. YAMLLINT_FILES+=("$line")
  28. done <<< "$(git ls-files './tests/*.yml' './searx/*.yml')"
  29. PYLINT_SEARX_DISABLE_OPTION="\
  30. I,C,R,\
  31. W0105,W0212,W0511,W0603,W0613,W0621,W0702,W0703,W1401,\
  32. E1136"
  33. PYLINT_ADDITIONAL_BUILTINS_FOR_ENGINES="supported_languages,language_aliases"
  34. PYLINT_OPTIONS="-m pylint -j 0 --rcfile .pylintrc"
  35. help() {
  36. cat <<EOF
  37. buildenv
  38. rebuild ./utils/brand.env
  39. babel.compile
  40. pybabel compile ./searx/translations
  41. data.*
  42. all : update searx/languages.py and ./data/*
  43. languages : update searx/data/engines_languages.json & searx/languages.py
  44. useragents: update searx/data/useragents.json with the most recent versions of Firefox.
  45. docs.*
  46. html : build HTML documentation
  47. live : autobuild HTML documentation while editing
  48. gh-pages : deploy on gh-pages branch
  49. prebuild : build reST include files (./${DOCS_BUILD}/includes)
  50. clean : clean documentation build
  51. docker
  52. build : build docker image
  53. push : build and push docker image
  54. gecko.driver
  55. download & install geckodriver if not already installed (required for
  56. robot_tests)
  57. node.*
  58. env : download & install npm dependencies locally
  59. clean : drop npm installations
  60. py.*
  61. build : Build python packages at ./${PYDIST}
  62. clean : delete virtualenv and intermediate py files
  63. pyenv.* :
  64. install : developer install of searx into virtualenv
  65. uninstall : uninstall developer installation
  66. cmd ... : run command ... in virtualenv
  67. OK : test if virtualenv is OK
  68. pypi.upload:
  69. Upload python packages to PyPi (to test use pypi.upload.test)
  70. test.* :
  71. pylint : lint PYLINT_FILES, searx/engines, searx & tests
  72. pep8 : pycodestyle (pep8) for all files except PYLINT_FILES
  73. unit : run unit tests
  74. coverage : run unit tests with coverage
  75. robot : run robot test
  76. clean : clean intermediate test stuff
  77. themes.* :
  78. all : build all themes
  79. oscar : build oscar theme
  80. simple : build simple theme
  81. EOF
  82. }
  83. if [ "$VERBOSE" = "1" ]; then
  84. SPHINX_VERBOSE="-v"
  85. PYLINT_VERBOSE="-v"
  86. fi
  87. # needed by sphinx-docs
  88. export DOCS_BUILD
  89. buildenv() {
  90. SEARX_DEBUG=1 pyenv.cmd python utils/build_env.py 2>&1 \
  91. | prefix_stdout "${_Blue}BUILDENV${_creset} "
  92. return "${PIPESTATUS[0]}"
  93. }
  94. babel.compile() {
  95. build_msg BABEL compile
  96. pyenv.cmd pybabel compile -d "${REPO_ROOT}/searx/translations"
  97. dump_return $?
  98. }
  99. data.all() {
  100. data.languages
  101. data.useragents
  102. build_msg DATA "update searx/data/ahmia_blacklist.txt"
  103. pyenv.cmd python searx_extra/update/update_ahmia_blacklist.py
  104. build_msg DATA "update searx/data/wikidata_units.json"
  105. pyenv.cmd python searx_extra/update/update_wikidata_units.py
  106. build_msg DATA "update searx/data/currencies.json"
  107. pyenv.cmd python searx_extra/update/update_currencies.py
  108. }
  109. data.languages() {
  110. ( set -e
  111. build_msg ENGINES "fetch languages .."
  112. pyenv.cmd python searx_extra/update/update_languages.py
  113. build_msg ENGINES "update update searx/languages.py"
  114. build_msg DATA "update searx/data/engines_languages.json"
  115. )
  116. dump_return $?
  117. }
  118. data.useragents() {
  119. build_msg DATA "update searx/data/useragents.json"
  120. pyenv.cmd python searx_extra/update/update_firefox_version.py
  121. dump_return $?
  122. }
  123. docs.prebuild() {
  124. build_msg DOCS "build ${DOCS_BUILD}/includes"
  125. (
  126. set -e
  127. [ "$VERBOSE" = "1" ] && set -x
  128. mkdir -p "${DOCS_BUILD}/includes"
  129. ./utils/searx.sh doc | cat > "${DOCS_BUILD}/includes/searx.rst"
  130. ./utils/filtron.sh doc | cat > "${DOCS_BUILD}/includes/filtron.rst"
  131. ./utils/morty.sh doc | cat > "${DOCS_BUILD}/includes/morty.rst"
  132. )
  133. dump_return $?
  134. }
  135. docker.push() {
  136. docker.build push
  137. }
  138. docker.buildx() {
  139. docker.build buildx
  140. }
  141. # shellcheck disable=SC2119
  142. docker.build() {
  143. pyenv.install
  144. build_msg DOCKER build
  145. # run installation in a subprocess and activate pyenv
  146. # See https://www.shellcheck.net/wiki/SC1001 and others ..
  147. # shellcheck disable=SC2031,SC2230,SC2002,SC2236,SC2143,SC1001
  148. ( set -e
  149. # shellcheck source=/dev/null
  150. source "${PY_ENV_BIN}/activate"
  151. # Check if it is a git repository
  152. if [ ! -d .git ]; then
  153. die 1 "This is not Git repository"
  154. fi
  155. if [ ! -x "$(which git)" ]; then
  156. die 1 "git is not installed"
  157. fi
  158. if ! git remote get-url origin 2> /dev/null; then
  159. die 1 "there is no remote origin"
  160. fi
  161. # This is a git repository
  162. # "git describe" to get the Docker version (for example : v0.15.0-89-g0585788e)
  163. # awk to remove the "v" and the "g"
  164. SEARX_GIT_VERSION=$(git describe --match "v[0-9]*\.[0-9]*\.[0-9]*" HEAD 2>/dev/null | awk -F'-' '{OFS="-"; $1=substr($1, 2); if ($3) { $3=substr($3, 2); } print}')
  165. # add the suffix "-dirty" if the repository has uncommited change
  166. # /!\ HACK for searx/searx: ignore utils/brand.env
  167. git update-index -q --refresh
  168. if [ ! -z "$(git diff-index --name-only HEAD -- | grep -v 'utils/brand.env')" ]; then
  169. SEARX_GIT_VERSION="${SEARX_GIT_VERSION}-dirty"
  170. fi
  171. # Get the last git commit id, will be added to the Searx version (see Dockerfile)
  172. VERSION_GITCOMMIT=$(echo "$SEARX_GIT_VERSION" | cut -d- -f2-4)
  173. build_msg DOCKER "Last commit : $VERSION_GITCOMMIT"
  174. # Check consistency between the git tag and the searx/version.py file
  175. # /! HACK : parse Python file with bash /!
  176. # otherwise it is not possible build the docker image without all Python
  177. # dependencies ( version.py loads __init__.py )
  178. # SEARX_PYTHON_VERSION=$(python3 -c "import six; import searx.version; six.print_(searx.version.VERSION_STRING)")
  179. SEARX_PYTHON_VERSION=$(cat searx/version.py | grep "\(VERSION_MAJOR\|VERSION_MINOR\|VERSION_BUILD\) =" | cut -d\= -f2 | sed -e 's/^[[:space:]]*//' | paste -sd "." -)
  180. if [ "$(echo "$SEARX_GIT_VERSION" | cut -d- -f1)" != "$SEARX_PYTHON_VERSION" ]; then
  181. err_msg "git tag: $SEARX_GIT_VERSION"
  182. err_msg "searx/version.py: $SEARX_PYTHON_VERSION"
  183. die 1 "Inconsistency between the last git tag and the searx/version.py file"
  184. fi
  185. # define the docker image name
  186. GITHUB_USER=$(echo "${GIT_URL}" | sed 's/.*github\.com\/\([^\/]*\).*/\1/')
  187. SEARX_IMAGE_NAME="${SEARX_IMAGE_NAME:-${GITHUB_USER:-searxng}/searxng}"
  188. BUILD="build"
  189. if [ "$1" = "buildx" ]; then
  190. # buildx includes the push option
  191. CACHE_TAG="${SEARX_IMAGE_NAME}:latest-build-cache"
  192. BUILD="buildx build --platform linux/amd64,linux/arm64,linux/arm/v7 --push --cache-from=type=registry,ref=$CACHE_TAG --cache-to=type=registry,ref=$CACHE_TAG,mode=max"
  193. shift
  194. fi
  195. build_msg DOCKER "Build command: ${BUILD}"
  196. # build Docker image
  197. build_msg DOCKER "Building image ${SEARX_IMAGE_NAME}:${SEARX_GIT_VERSION}"
  198. # shellcheck disable=SC2086
  199. docker $BUILD \
  200. --build-arg BASE_IMAGE="${DEPENDENCIES_IMAGE_NAME}" \
  201. --build-arg GIT_URL="${GIT_URL}" \
  202. --build-arg SEARX_GIT_VERSION="${SEARX_GIT_VERSION}" \
  203. --build-arg VERSION_GITCOMMIT="${VERSION_GITCOMMIT}" \
  204. --build-arg LABEL_DATE="$(date -u +"%Y-%m-%dT%H:%M:%SZ")" \
  205. --build-arg LABEL_VCS_REF="$(git rev-parse HEAD)" \
  206. --build-arg LABEL_VCS_URL="${GIT_URL}" \
  207. --build-arg TIMESTAMP_SETTINGS="$(git log -1 --format="%cd" --date=unix -- searx/settings.yml)" \
  208. --build-arg TIMESTAMP_UWSGI="$(git log -1 --format="%cd" --date=unix -- dockerfiles/uwsgi.ini)" \
  209. -t "${SEARX_IMAGE_NAME}:latest" -t "${SEARX_IMAGE_NAME}:${SEARX_GIT_VERSION}" .
  210. if [ "$1" = "push" ]; then
  211. docker push "${SEARX_IMAGE_NAME}:latest"
  212. docker push "${SEARX_IMAGE_NAME}:${SEARX_GIT_VERSION}"
  213. fi
  214. )
  215. dump_return $?
  216. }
  217. # shellcheck disable=SC2119
  218. gecko.driver() {
  219. pyenv.install
  220. build_msg INSTALL "gecko.driver"
  221. # run installation in a subprocess and activate pyenv
  222. ( set -e
  223. # shellcheck source=/dev/null
  224. source "${PY_ENV_BIN}/activate"
  225. # TODO : check the current geckodriver version
  226. geckodriver -V > /dev/null 2>&1 || NOTFOUND=1
  227. set +e
  228. if [ -z "$NOTFOUND" ]; then
  229. build_msg INSTALL "geckodriver already installed"
  230. return
  231. fi
  232. PLATFORM="$(python3 -c 'import platform; print(platform.system().lower(), platform.architecture()[0])')"
  233. case "$PLATFORM" in
  234. "linux 32bit" | "linux2 32bit") ARCH="linux32";;
  235. "linux 64bit" | "linux2 64bit") ARCH="linux64";;
  236. "windows 32 bit") ARCH="win32";;
  237. "windows 64 bit") ARCH="win64";;
  238. "mac 64bit") ARCH="macos";;
  239. esac
  240. GECKODRIVER_URL="https://github.com/mozilla/geckodriver/releases/download/$GECKODRIVER_VERSION/geckodriver-$GECKODRIVER_VERSION-$ARCH.tar.gz";
  241. build_msg GECKO "Installing ${PY_ENV_BIN}/geckodriver from $GECKODRIVER_URL"
  242. FILE="$(mktemp)"
  243. wget -qO "$FILE" -- "$GECKODRIVER_URL" && tar xz -C "${PY_ENV_BIN}" -f "$FILE" geckodriver
  244. rm -- "$FILE"
  245. chmod 755 -- "${PY_ENV_BIN}/geckodriver"
  246. )
  247. dump_return $?
  248. }
  249. node.env() {
  250. local err=0
  251. pushd "${REPO_ROOT}" &> /dev/null
  252. # shellcheck disable=SC2230
  253. which npm &> /dev/null || die 1 'node.env - npm is not found!'
  254. ( set -e
  255. # shellcheck disable=SC2030
  256. PATH="$(npm bin):$PATH"
  257. export PATH
  258. build_msg INSTALL "npm install $NPM_PACKAGES"
  259. # shellcheck disable=SC2086
  260. npm install $NPM_PACKAGES
  261. cd "${REPO_ROOT}/searx/static/themes/oscar"
  262. build_msg INSTALL "($(pwd)) npm install"
  263. npm install
  264. build_msg INSTALL "($(pwd)) npm install"
  265. cd "${REPO_ROOT}/searx/static/themes/simple"
  266. npm install
  267. )
  268. err=$?
  269. popd &> /dev/null
  270. dump_return "$err"
  271. }
  272. node.clean() {
  273. build_msg CLEAN "locally installed npm dependencies"
  274. rm -rf \
  275. ./node_modules \
  276. ./package-lock.json \
  277. ./searx/static/themes/oscar/package-lock.json \
  278. ./searx/static/themes/oscar/node_modules \
  279. ./searx/static/themes/simple/package-lock.json \
  280. ./searx/static/themes/simple/node_modules
  281. dump_return $?
  282. }
  283. py.build() {
  284. build_msg BUILD "[pylint] python package ${PYDIST}"
  285. pyenv.cmd python setup.py \
  286. sdist -d "${PYDIST}" \
  287. bdist_wheel --bdist-dir "${PYBUILD}" -d "${PYDIST}"
  288. }
  289. py.clean() {
  290. build_msg CLEAN pyenv
  291. ( set -e
  292. pyenv.drop
  293. [ "$VERBOSE" = "1" ] && set -x
  294. rm -rf "${PYDIST}" "${PYBUILD}" "${PY_ENV}" ./.tox ./*.egg-info
  295. find . -name '*.pyc' -exec rm -f {} +
  296. find . -name '*.pyo' -exec rm -f {} +
  297. find . -name __pycache__ -exec rm -rf {} +
  298. )
  299. }
  300. pyenv.check() {
  301. cat <<EOF
  302. import yaml
  303. print('import yaml --> OK')
  304. EOF
  305. }
  306. pyenv.install() {
  307. if ! pyenv.OK; then
  308. py.clean > /dev/null
  309. fi
  310. if pyenv.install.OK > /dev/null; then
  311. return 0
  312. fi
  313. ( set -e
  314. pyenv
  315. build_msg PYENV "[install] pip install -e 'searx${PY_SETUP_EXTRAS}'"
  316. "${PY_ENV_BIN}/python" -m pip install -e ".${PY_SETUP_EXTRAS}"
  317. buildenv
  318. )
  319. local exit_val=$?
  320. if [ ! $exit_val -eq 0 ]; then
  321. die 42 "error while pip install (${PY_ENV_BIN})"
  322. fi
  323. }
  324. pyenv.uninstall() {
  325. build_msg PYENV "[pyenv.uninstall] uninstall packages: ${PYOBJECTS}"
  326. pyenv.cmd python setup.py develop --uninstall 2>&1 \
  327. | prefix_stdout "${_Blue}PYENV ${_creset}[pyenv.uninstall] "
  328. }
  329. pypi.upload() {
  330. py.clean
  331. py.build
  332. # https://github.com/pypa/twine
  333. pyenv.cmd twine upload "${PYDIST}"/*
  334. }
  335. pypi.upload.test() {
  336. py.clean
  337. py.build
  338. pyenv.cmd twine upload -r testpypi "${PYDIST}"/*
  339. }
  340. test.yamllint() {
  341. build_msg TEST "[pylint] \$PYLINT_FILES"
  342. pyenv.cmd yamllint --format parsable "${YAMLLINT_FILES[@]}"
  343. }
  344. test.pylint() {
  345. # shellcheck disable=SC2086
  346. ( set -e
  347. build_msg TEST "[pylint] \$PYLINT_FILES"
  348. pyenv.cmd python ${PYLINT_OPTIONS} ${PYLINT_VERBOSE} \
  349. "${PYLINT_FILES[@]}"
  350. build_msg TEST "[pylint] searx/engines"
  351. pyenv.cmd python ${PYLINT_OPTIONS} ${PYLINT_VERBOSE} \
  352. --disable="${PYLINT_SEARX_DISABLE_OPTION}" \
  353. --additional-builtins="${PYLINT_ADDITIONAL_BUILTINS_FOR_ENGINES}" \
  354. searx/engines
  355. build_msg TEST "[pylint] searx tests"
  356. pyenv.cmd python ${PYLINT_OPTIONS} ${PYLINT_VERBOSE} \
  357. --disable="${PYLINT_SEARX_DISABLE_OPTION}" \
  358. --ignore=searx/engines \
  359. searx tests
  360. )
  361. dump_return $?
  362. }
  363. test.pep8() {
  364. build_msg TEST 'pycodestyle (formerly pep8)'
  365. local _exclude=""
  366. printf -v _exclude '%s, ' "${PYLINT_FILES[@]}"
  367. pyenv.cmd pycodestyle \
  368. --exclude="searx/static, searx/languages.py, $_exclude " \
  369. --max-line-length=120 \
  370. --ignore "E117,E252,E402,E722,E741,W503,W504,W605" \
  371. searx tests
  372. dump_return $?
  373. }
  374. test.unit() {
  375. build_msg TEST 'tests/unit'
  376. pyenv.cmd python -m nose2 -s tests/unit
  377. dump_return $?
  378. }
  379. test.coverage() {
  380. build_msg TEST 'unit test coverage'
  381. ( set -e
  382. pyenv.cmd python -m nose2 -C --log-capture --with-coverage --coverage searx -s tests/unit
  383. pyenv.cmd coverage report
  384. pyenv.cmd coverage html
  385. )
  386. dump_return $?
  387. }
  388. test.robot() {
  389. build_msg TEST 'robot'
  390. gecko.driver
  391. PYTHONPATH=. pyenv.cmd python searx/testing.py robot
  392. dump_return $?
  393. }
  394. test.clean() {
  395. build_msg CLEAN "test stuff"
  396. rm -rf geckodriver.log .coverage coverage/
  397. dump_return $?
  398. }
  399. themes.all() {
  400. ( set -e
  401. node.env
  402. themes.oscar
  403. themes.simple
  404. )
  405. dump_return $?
  406. }
  407. themes.oscar() {
  408. local gruntfile=searx/static/themes/oscar/gruntfile.js
  409. build_msg GRUNT "${gruntfile}"
  410. PATH="$(npm bin):$PATH" grunt --gruntfile "${gruntfile}"
  411. dump_return $?
  412. }
  413. themes.simple() {
  414. local gruntfile=searx/static/themes/simple/gruntfile.js
  415. build_msg GRUNT "${gruntfile}"
  416. PATH="$(npm bin):$PATH" grunt --gruntfile "${gruntfile}"
  417. dump_return $?
  418. }
  419. PYLINT_FILES=()
  420. while IFS= read -r line; do
  421. PYLINT_FILES+=("$line")
  422. done <<< "$(pylint.FILES)"
  423. # shellcheck disable=SC2119
  424. main() {
  425. local _type
  426. local cmd="$1"; shift
  427. if [ "$cmd" == "" ]; then
  428. help
  429. err_msg "missing command"
  430. return 42
  431. fi
  432. case "$cmd" in
  433. --getenv) var="$1"; echo "${!var}";;
  434. --help) help;;
  435. --*)
  436. help
  437. err_msg "unknown option $cmd"
  438. return 42
  439. ;;
  440. *)
  441. _type="$(type -t "$cmd")"
  442. if [ "$_type" != 'function' ]; then
  443. err_msg "unknown command $1 / use --help"
  444. return 42
  445. else
  446. "$cmd" "$@"
  447. fi
  448. ;;
  449. esac
  450. }
  451. main "$@"